#include "stdio.h"
#include "Fourier.h"
#define NFREQ  4
double Wsin[NFREQ]={1,0.5,0.4,0.2};
double Wcos[NFREQ]={0.8,0.6,0.3,0.2};
complex X[MAX+1], Y1[MAX+1], Y2[MAX+1];
void setData(){
	double D=2*PI/MAX;
	double W1=1, W2=0.5;
	for(int i=0;i<=MAX; i++){
		X[i].r = 0;
		for(int k=0; k<NFREQ;k++){
		   X[i].r += Wsin[k]*sin((k+1)*D*i)+Wcos[k]*cos((k+1)*D*i);
		}
		X[i].i=0; 
	}
}
void printDt(int img, complex X[]){
	double vmax=X[0].r, vmin=X[0].r, V;int N, N0, NM;
	for(int i=0;i<=MAX;i++){
		if(vmax<X[i].r) vmax=X[i].r;
		if(vmin>X[i].r) vmin=X[i].r;
		if(vmax<X[i].i) vmax=X[i].i;
		if(vmin>X[i].i) vmin=X[i].i;
	}
	NM=53;
	N0=-vmin*50/(vmax-vmin)+1.5;
	for(int i=0;i<=MAX;i++){
		V=X[i].r; if(img) V=X[i].i;
		printf("\n%10.4f ", V);
		N=(V-vmin)*50/(vmax-vmin)+1.5;
		for(int k=0; k<NM; k++){
			if(k==N)printf("*");
			else {if(k==N0) printf("+"); else printf("-");}
		}
	}
}
int main(void){
	setData();
	printDt(false, X);
	DFT(X,Y1,MAX);IDFT(Y1,Y2,MAX);
	getchar();
	printf("\n DFT @\n");printDt(false, Y1);
	getchar();
	printf("\n DFT @\n");printDt(true, Y1);
	getchar();
	printf("\n IDFT @\n");printDt(false, Y2);
	getchar();
	printf("\n IDFT @\n");printDt(true, Y2);
	getchar();
}